/**************************************************************************
*                     X J D X G E N
*                                                   Author: Jim Breen
*
*   This is the Unix version of JDXGEN, ported from MS-DOS
*      (Hitoshi Doi tidied up a little)
***************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>

#include <stdio.h>
/*#include <stdlib.h>*/
#include <ctype.h>
#include <string.h>

#define TRUE 1
#define FALSE 0

unsigned char *db;
struct stat *buf;
unsigned long dbyte;
unsigned long  *jindex;
unsigned long indptr,lone;
unsigned char Dname[30] = {"edict"};
unsigned char JDXname[30] = {"edict.xjdx"};
unsigned char wds[] ={"abbr col vul vulg then and conj int pron pref suf syn ant from adv adj hon hum pol jap japanese "};
unsigned char *exlist[100];		/* list of words to be excluded */
int excount,exlens[100];
int jiver = 14;		/*The last time the index structure changed was Version1.4*/

/*====== prototypes=================================================*/
int stringcomp(unsigned char *s1, unsigned char *s2);
void jqsort(long i, long j);
int alphaoreuc(unsigned char c);
int Kstrcmp(unsigned long lhs, unsigned long rhs);
void ExSet();
int alphaoreuc(unsigned char x);

int stringcomp(unsigned char *s1, unsigned char *s2)
{
	int i;
	unsigned char c1,c2;

	for(i = 0; i < strlen(s1);i++) 
	{
		c1 = s1[i];
		if (c1 < 0x60) c1 = (c1|0x20);
		c2 = s2[i];
		if (c2 < 0x60) c2 = (c2|0x20);
		if (c1 != c2) return(1);
	}
	return (0);
}

/*====function to Load Dictionary and load/create index table=======*/
main(argc,argv)
int argc;
unsigned char **argv;
{
  FILE *fp,*fopen();
  unsigned long possav,schi,diclen,indlen;
  int i,inwd,cstrp,saving,isc,nodread;
  unsigned char c;
  unsigned char currstr[40],strtmp[50];
  unsigned char **ap;

  printf("\nXJDXGEN V1.1 Index Table Generator for XJDIC. \n      Copyright J.W. Breen, 1993\n");
  if (argc > 1)
  {
	ap = argv;
	ap++;
	if(strcmp(*ap,"-h") == 0)
	{
		printf("\nThere are two command-line options:\n  -h  this display\n   filename - file to be indexed\n\n");
		exit(0);
	}
	strcpy(strtmp,*ap);
	strcpy(Dname,*ap);
	strcpy(JDXname,*ap);
	strcat(JDXname,".xjdx");
    printf("Commandline request to use files %s and %s \n",Dname,JDXname);
  }
  ExSet();
  inwd = FALSE;
  indptr = 1;
  lone = 1;
  buf = (void *)malloc(1000);
  if(stat(Dname, buf) != 0)
  {
	 perror(NULL);
	 printf("Cannot stat: %s \n",Dname);
	 exit(0);
  }
  diclen = buf->st_size;
  printf("\nWARNING!!  This program may take a long time to run .....\n");

  puts ("\nLoading Dictionary file.  Please wait.....\n");
  fp=fopen(Dname,"rb");
  if (fp==NULL )
  {
	printf("\nCannot open dictionary file\n");
	exit(0);
  }
  db = (unsigned char *)calloc(diclen+100, sizeof(unsigned char));
  if(db == NULL)
  {
      fprintf(stderr,"calloc() for dictionary failed.\n");
      fclose(fp);
      exit(0);
  }
  nodread = diclen/1024;
  dbyte = fread((unsigned char *)db+1, 1024, nodread, fp);
  nodread = diclen % 1024;
  dbyte = fread((unsigned char *)(db+(diclen/1024)*1024)+1, nodread,1, fp);
  fclose(fp);
  diclen++;
  dbyte = diclen;
  db[diclen] = 10;
  db[0] = 10;
  printf("Dictionary size: %d bytes.\n",dbyte);
  indlen = diclen * sizeof(long);
  jindex = (unsigned long *)calloc(diclen, sizeof(unsigned long));
  if(jindex == NULL)
  {
	  fprintf(stderr,"calloc() for index table failed.\n");
	  fclose(fp);
	  exit(0);
  }
  printf("Parsing.... \n");
  /*this is the dictionary parser. It places an entry in jindex for every
   kana/kanji string and every alphabetic string it finds which is >=3
   characters and is not on the "exclude" list */
  indptr = 1;
  saving = FALSE;
  cstrp = 0;
  for (schi =0; schi < dbyte; schi++) /* scan whole dictionary  */
  {
	  c = db[schi];
	  if (inwd)
	  {
		  if ((alphaoreuc(c))||(c == '-')||(c == '.')||((c >= '0') && (c <= '9')))
		  {
			  currstr[cstrp] = c;
			  cstrp++;
		  }
		  else
		  {
			  currstr[cstrp] = '\0';
			  inwd = FALSE;
			  if ((strlen(currstr) <= 2) && (currstr[0] < 127))saving = FALSE;
			  if ((strlen(currstr) == 2) && (currstr[1] <= '9'))saving = TRUE;
			  if (saving && (currstr[0] > 127))
			  {
				  possav = jindex[indptr];
				  indptr++;
                                  if (indptr > indlen/sizeof(long))
                                  {
                                          printf("Index table overflow. Dictionary too large?\n");
                                          exit(0);
                                  }

				for (i = 2; i < strlen(currstr); i+=2)
				{
					if(currstr[i] > 0xa5)
					{
						jindex[indptr] = possav+i;
						indptr++;
                                  		if (indptr > indlen/sizeof(long))
                                  		{
                                          		printf("Index table overflow. Dictionary too large?\n");
                                          		exit(0);
                                  		}
					}
				}
			  }
			  if (saving && (currstr[0] < 127))
			  {
				  indptr++;
				  if (indptr > indlen/sizeof(long))
				  {
					  printf("Index table overflow. Dictionary too large?\n");
					  exit(0);
				  }
				  if (currstr[0] < 128)
				  {
					  for (isc = 0; isc <= excount; isc++)
					  {
						  if (( exlens[isc] == strlen(currstr)) &&
						  (stringcomp(currstr,exlist[isc]) == 0)   )
						  {
							  indptr--;
							  break;
						  }
					  }
				  }
			  }
		  }
	  }
	  else
	  {
		  if (alphaoreuc(c))
		  {
			  inwd = TRUE;
			  jindex[indptr] = schi;
			  cstrp = 1;
			  currstr[0] = c;
			  currstr[1] = '\0';
			  saving = TRUE;
		  }
	  }
    }
    indptr--;
    printf("Index entries: %d  \nSorting (this is slow)......\n",indptr);
    jqsort(lone,indptr);
    printf("Sorted\nWriting index file ....\n");
    fp = fopen(JDXname,"wb");
    if (fp==NULL )
    {
    printf("\nCannot open %s output file\n",JDXname);
    exit(0);
  }
  jindex[0] = diclen+jiver;
  fwrite(jindex,sizeof(long),indptr+1,fp);
  fclose(fp);
}
/*======function to sort jindex table====================*/
void jqsort(long lhs, long rhs)
{
	long i,last,midp;
	unsigned long temp;
	if (lhs >= rhs) return;
	/* Swap ( lhs , (lhs+rhs)/2);*/
	midp = (lhs+rhs)/2;
	temp = jindex[lhs];
	jindex[lhs] = jindex[midp];
	jindex[midp] = temp;
	last = lhs;
	for (i = lhs+1;i <= rhs; i++)
		{
			if (Kstrcmp(jindex[i],jindex[lhs]) < 0)
			{
				/* Swap(++last,i);*/
				last++;
				temp = jindex[i];
				jindex[i] = jindex[last];
				jindex[last] = temp;
			}
		}
/*	Swap (lhs,last);*/
	temp = jindex[lhs];
	jindex[lhs] = jindex[last];
	jindex[last] = temp;
	jqsort(lhs,last-1);
	jqsort(last+1,rhs);
}
/*=====string comparison used by jqsort==========================*/
int Kstrcmp(unsigned long lhs, unsigned long rhs)
{
	int i,c1,c2;
/* effectively does a strnicmp on two "strings" within the dictionary,
   except it will make katakana and hirgana match (EUC A4 & A5) */

	for (i = 0; i<20 ; i++)
	{
		c1 = db[lhs+i];
		c2 = db[rhs+i];
		if ((i % 2) == 0)
		{
			if (c1 == 0xA5)
			{
				c1 = 0xA4;
			}
			if (c2 == 0xA5)
			{
				c2 = 0xA4;
			}
		}
		if ((c1 >= 'A') && (c1 <= 'Z')) c1 |= 0x20;
		if ((c2 >= 'A') && (c2 <= 'Z')) c2 |= 0x20;
		if (c1 != c2 ) break;
	}
	return(c1-c2);
}
/*=========function to set up the exclusion list for the index=========*/
void ExSet()
{
	unsigned char *ptr;

	int i;
/*  WARNING - do not put more than 100 words into this list		*/
	ptr = (unsigned char *)strtok(wds," ");
	i = 0;
	while (ptr != NULL)
	{
		exlist[i] = ptr;
		exlens[i] = strlen(exlist[i]);
		i++;
		ptr = (unsigned char *)strtok(NULL," ");
	}
excount = i-1;
}
/*=======function to test a character for alpha or kana/kanji====*/
int alphaoreuc(unsigned char x)
{
	int c;

	c = x & 0xff;
	if(((c >= 65) && (c <= 90)) || ((c >= 97) && (c <= 122)))
	{
		return (TRUE);
	}
	if ((c >= '0') && (c <= '9'))
	{
		return(TRUE);
	}
	if ((c & 0x80) > 0)
	{
		return(TRUE);
	}
	return (FALSE);
}

